--------------------------------------------------------------------------------
-- Copyright  2021								|
-- All Rights Reserved.								|
-- 										|
-- Permission to use, copy, modify, and distribute this software in any way	|
-- is not granted without expressed written agreement. This copyright applies	|
-- to the all code, data and artwork related to this project and all associated	|
-- projects published by the author.						|
--										|
-- More information on copyright is available from sources on-line.		|
-- Use an actual factual one!							|
--------------------------------------------------------------------------------

local addonName, NS = ...

local Lib = NS.FizzleLib

--------------------------- Nudge Buttons -------------------------------------------------
local function Nudge_OnClick(self, button)
	if (button == "RightButton") then
		self.Data[self.Index] = self.Data[self.Index] + self.bumpval
	elseif (self.moving) then
		self.Data[self.Index] = self.Data[self.Index] + self.glideval
	else
		self.Data[self.Index] = self.Data[self.Index] + self.nudgeval
	end
	if self.PostUpdate then
		self:PostUpdate(button) --self, button)
	end
end
	
local function Nudge_OnUpdate(self, elapsed)
	if not self.timer then
		self.timer = .05
	end
	self.timer = self.timer - elapsed
	if self.timer < 0 then
		self.timer = .05
		if self.moving then
			Nudge_OnClick(self, button)
		end
	end
end

function Lib:CreateNudgeButton(name, parent, data, index, nudgeval, bumpval, glideval, width, height, enabled)
	local w = width or 24
	local h = height or 24
	local f = Lib:CreateDefaultButton(name, parent, w, h)
	f:RegisterForClicks("LeftButtonUp", "RightButtonUp", "MiddleButtonUp")
--	f.Index = index
	Lib.InitData(f, data, index)
--	f.initdata(f, data, index)

	f.nudgeval = nudgeval
	f.bumpval = bumpval
	f.glideval = glideval
	f:SetScript("OnMouseDown", function(self, button)
		if button == "MiddleButton" then
			self.moving = true
		end
	end)
	f:SetScript("OnMouseUp", function(self, button)
		if button == "MiddleButton" then
			self.moving = nil
		else
			Nudge_OnClick(self, button)
		end
	end)
	f:SetScript("OnUpdate", function(self, elapsed)
			Nudge_OnUpdate(self, elapsed)
	end)
--	Lib:AddLabelFuncs(f)
	return f
end
